<template>
  <div
    v-if="sections.length"
    class="home"
    :class="{ ' is-subscribed': aboArea && userSubscribed }"
  >
    <div v-for="(section, index) of sections" :key="`section-${index}`">
      <LazySerieSection
        v-if="section.type === 'selection'"
        :data="section.data"
        :should-be-loaded="
          canLoadSelection(`${section.data.reference}-${index}`)
        "
        :is-subscription="aboArea"
        @loaded="loadNextSelection()"
      />
      <component
        :is="getSection(section)"
        v-else-if="
          getSection(section) === 'CtaSubscriptionSection' ||
          getSection(section) === 'CtaPreferenceSection' ||
          getSection(section) === 'EditoSection' ||
          (section.data.items && section.data.items.length)
        "
        :data="section.data"
      />
    </div>
    <client-only>
      <AlbumGiftModal
        v-if="albumGiftModal && $store.state.displayAlbumGiftModal"
        @display-modal="updateDisplayModal('album-gift')"
      />
      <PreferenceModal
        v-if="preferenceModal && $store.state.displayPreferenceModal"
        @display-modal="updateDisplayModal('preference')"
      />
    </client-only>
  </div>
</template>

<script>
//import preloadUser from '~/plugins/load-user-data'
import { hydrateWhenVisible } from 'vue-lazy-hydration'
import EditoSection from '~/components/sections/EditoSection'
import FavoritesSection from '~/components/sections/FavoritesSection'
import CtaAlbumRatingSection from '~/components/sections/CtaAlbumRatingSection'
import CtaPreferenceSection from '~/components/sections/CtaPreferenceSection'
import AlbumPreorderSection from '@/components/sections/AlbumPreorderSection'
import AlbumExcluSection from '@/components/sections/AlbumExcluSection'
import AlbumSponsoredSection from '@/components/sections/AlbumSponsoredSection'
import PreferenceModal from '@/components/modals/PreferenceModal'
import AlbumGiftModal from '@/components/modals/AlbumGiftModal'
import SlidesSection from '@/components/sections/SlidesSection'
import CtaSubscriptionSection from '@/components/sections/CtaSubscriptionSection'

export default {
  components: {
    SlidesSection,
    LazySerieSection: hydrateWhenVisible(
      () => import('~/components/sections/SerieSection'),
      { observerOptions: { rootMargin: '50px' } }
    ),
    EditoSection,
    FavoritesSection,
    CtaSubscriptionSection,
    CtaAlbumRatingSection,
    CtaPreferenceSection,
    AlbumPreorderSection,
    AlbumExcluSection,
    AlbumSponsoredSection,
    PreferenceModal,
    AlbumGiftModal
  },

  async fetch() {
    if (!this.sections || !this.sections.length) {
      await this.loadData()
    }
  },

  data() {
    return {
      sections: [],
      selections: [],
      selectionIndex: 0,
      isSubscription: false,
      displayAlbumGiftModal: true,
      displayPreferenceModal: false
    }
  },
  computed: {
    ui() {
      return this.$store.state.auth &&
        this.$store.state.auth.loggedIn &&
        this.$store.state.auth.user
        ? this.$store.state.auth.user
        : {}
    },
    isAuthenticated() {
      return this.$auth.loggedIn
    },
    preferenceModal() {
      if (this.$store.state.auth.user && this.displayPreferenceModal) {
        return !!this.$store.state.auth.user.preferenceUnset
      }
      return false
    },
    albumGiftModal() {
      if (this.$store.state.auth.user && this.displayAlbumGiftModal) {
        return !this.$store.state.auth.user.usedGift
      }
      return false
    },
    userSubscribed() {
      return 'hasActiveClassicSubscription' in this.ui
        ? this.ui.hasActiveClassicSubscription
        : false
    },
    aboArea() {
      return this.$utils.aboArea()
    }
  },
  watch: {
    async isAuthenticated() {
      this.updateGtmData()
    }
  },
  async mounted() {
    this.updateGtmData()
  },
  methods: {
    // will return the correct Component's Name by the section.type
    getSection(section) {
      switch (section.type) {
        case 'slides':
          return 'SlidesSection'
        case 'selection':
          return 'SerieSection'
        case 'edito':
          return 'EditoSection'
        case 'sr-favorites':
          return 'FavoritesSection'
        case 'cta-subscription':
          return 'CtaSubscriptionSection'
        case 'cta-album-rating':
          return 'CtaAlbumRatingSection'
        case 'cta-preference':
          return 'CtaPreferenceSection'
        case 'album-preorder':
          return 'AlbumPreorderSection'
        case 'album-exclu':
          return 'AlbumExcluSection'
        case 'album-sponsored':
          return 'AlbumSponsoredSection'
      }
    },

    async loadData() {
      this.isSubscription = this.aboArea
      this.selectionIndex = 0
      const subArea = this.userSubscribed && this.aboArea ? 1 : false
      await this.$store.dispatch('updateHomepageData', {
        force: true,
        subArea: subArea,
        locale: this.$i18n.locale
      })
      const data = this.$store.state.homepageData
      if (data) {
        if (process.server) {
          // load data for all carousels
          // await this.preloadAllSelectionSections()

          // load data for first non-empty carousel
          await this.preloadFirstSelectionSection(data.sections)
        }

        this.selections = data.selections
        this.sections = data.sections
      }
    },

    async preloadAllSelectionSections(sections) {
      for (let i = 0; i < sections.length; i++) {
        const section = sections[i]
        if (section.type === 'selection') {
          await this.preloadSelectionSection(section)
        }
      }
    },

    async preloadFirstSelectionSection(sections) {
      for (let i = 0; i < sections.length; i++) {
        const section = sections[i]
        if (section.type === 'selection') {
          if (!section.data.series || !section.data.series.length) {
            await this.preloadSelectionSection(section)
          }

          if (section.data.series && section.data.series.length >= 6) {
            return section.reference
          }
        }
      }
      return ''
    },

    async preloadSelectionSection(section) {
      if (
        section.type === 'selection' &&
        (!section.data.series || !section.data.series.length)
      ) {
        const { reference, shelf, itemId } = section.data
        const subArea = this.aboArea ? '1' : '0'

        section.data.series = await this.$api.list(
          reference,
          shelf || null,
          itemId || null,
          subArea
        )

        if (section.data.series && section.data.series.length < 6) {
          section.data.series = []
        }
      }
    },

    // These methods are used to load Serie's Section one after one
    canLoadSelection(reference) {
      return (
        process.server || this.selections[this.selectionIndex] === reference
      )
    },
    loadNextSelection() {
      this.selectionIndex++
    },
    updateDisplayModal(modal) {
      if (modal === 'preference') {
        this.displayPreferenceModal = false
        this.$store.dispatch('hideCookieModal', 'preference')
      }
      if (modal === 'album-gift') {
        this.displayAlbumGiftModal = false
        this.displayPreferenceModal = true
        this.$store.dispatch('hideCookieModal', 'album-gift')
      }
    },
    updateGtmData() {
      if (process.client) {
        this.$utils.gtmUpdateDataLayer()
        this.$utils.gtmPush({
          pageType: 'Accueil'
        })
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.home {
  @media (max-width: 1259px) {
    padding-top: 85px;
  }

  @media (max-width: 1024px) {
    padding-top: 70px;
  }
}

// fixing bad behavior due to legacy
.site-content {
  .home {
    @media (max-width: 1259px) {
      padding-top: 1px; // use to prevent bad behavior
    }

    @media (max-width: 1024px) {
      padding-top: 1px; // use to prevent bad behavior
    }

    @media (max-width: 768px) {
      padding-top: 0;
    }
  }
}
</style>
